Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 3211)
@@ -58,4 +58,12 @@
    REAL(wp) ::   rbcp   ! Brown & Campana parameters for semi-implicit hpg
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -93,6 +101,8 @@
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
       !!
-      INTEGER  ::   jk, jn    ! dummy loop indices
-      REAL(wp) ::   zfact     ! local scalars
+      INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
+      REAL(wp) ::   zfact            ! local scalar
+
+!FTRANS ztrdt ztrds :I :I :z
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
@@ -142,7 +152,17 @@
       IF( neuler == 0 .AND. kt == nit000 ) THEN       ! Euler time-stepping at first time-step (only swap)
          DO jn = 1, jpts
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  DO jk = 1, jpkm1
+                     tsn(ji,jj,jk,jn) = tsa(ji,jj,jk,jn)    
+                  END DO
+               END DO
+            END DO
+#else
             DO jk = 1, jpkm1
                tsn(:,:,jk,jn) = tsa(:,:,jk,jn)    
             END DO
+#endif
          END DO
       ELSE                                            ! Leap-Frog + Asselin filter time stepping
@@ -162,4 +182,15 @@
       ! trends computation
       IF( l_trdtra ) THEN      ! trend of the Asselin filter (tb filtered - tb)/dt     
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  zfact = 1.e0 / r2dtra(jk)             
+                  ztrdt(ji,jj,jk) = ( tsb(ji,jj,jk,jp_tem) - ztrdt(ji,jj,jk) ) * zfact
+                  ztrds(ji,jj,jk) = ( tsb(ji,jj,jk,jp_sal) - ztrds(ji,jj,jk) ) * zfact
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             zfact = 1.e0 / r2dtra(jk)             
@@ -167,4 +198,5 @@
             ztrds(:,:,jk) = ( tsb(:,:,jk,jp_sal) - ztrds(:,:,jk) ) * zfact
          END DO
+#endif
          CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_atf, ztrdt )
          CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_atf, ztrds )
@@ -178,4 +210,12 @@
    END SUBROUTINE tra_nxt
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    SUBROUTINE tra_nxt_fix( kt, cdtype, ptb, ptn, pta, kjpt )
@@ -205,7 +245,14 @@
       CHARACTER(len=3), INTENT(in   )                               ::   cdtype   ! =TRA or TRC (tracer indicator)
       INTEGER         , INTENT(in   )                               ::   kjpt     ! number of tracers
-      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptb      ! before tracer fields
-      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptn      ! now tracer fields
-      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   pta      ! tracer trend
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptb      ! before tracer fields
+!     REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptn      ! now tracer fields
+!     REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   pta      ! tracer trend
+
+!FTRANS ptb ptn pta :I :I :z :
+      REAL(wp)        , INTENT(inout)             ::   ptb(jpi,jpj,jpk,kjpt)      ! before tracer fields
+      REAL(wp)        , INTENT(inout)             ::   ptn(jpi,jpj,jpk,kjpt)      ! now tracer fields
+      REAL(wp)        , INTENT(inout)             ::   pta(jpi,jpj,jpk,kjpt)      ! tracer trend
       !
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
@@ -226,7 +273,13 @@
       DO jn = 1, kjpt
          !
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   ztn = ptn(ji,jj,jk,jn)                                    
                   ztd = pta(ji,jj,jk,jn) - 2. * ztn + ptb(ji,jj,jk,jn)      !  time laplacian on tracers
@@ -244,4 +297,12 @@
    END SUBROUTINE tra_nxt_fix
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    SUBROUTINE tra_nxt_vvl( kt, cdtype, ptb, ptn, pta, kjpt )
@@ -272,7 +333,15 @@
       CHARACTER(len=3), INTENT(in   )                               ::   cdtype   ! =TRA or TRC (tracer indicator)
       INTEGER         , INTENT(in   )                               ::   kjpt     ! number of tracers
-      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptb      ! before tracer fields
-      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptn      ! now tracer fields
-      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   pta      ! tracer trend
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptb      ! before tracer fields
+!     REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptn      ! now tracer fields
+!     REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   pta      ! tracer trend
+
+!FTRANS ptb ptn pta :I :I :z :
+      REAL(wp)        , INTENT(inout)             ::   ptb(jpi,jpj,jpk,kjpt)      ! before tracer fields
+      REAL(wp)        , INTENT(inout)             ::   ptn(jpi,jpj,jpk,kjpt)      ! now tracer fields
+      REAL(wp)        , INTENT(inout)             ::   pta(jpi,jpj,jpk,kjpt)      ! tracer trend
+
       !!     
       LOGICAL  ::   ll_tra, ll_tra_hpg, ll_traqsr   ! local logical
@@ -299,4 +368,12 @@
       !
       DO jn = 1, kjpt      
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  !! DCSE_NEMO: could try promoting these scalars to vectors
+                  zfact1 = atfp * rdttra(jk)
+                  zfact2 = zfact1 / rau0
+#else
          DO jk = 1, jpkm1
             zfact1 = atfp * rdttra(jk)
@@ -304,4 +381,5 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   ze3t_b = fse3t_b(ji,jj,jk)
                   ze3t_n = fse3t_n(ji,jj,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 3211)
@@ -53,4 +53,10 @@
    REAL(wp), DIMENSION(3,61) ::   rkrgb   !: tabulated attenuation coefficients for RGB absorption
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -94,4 +100,7 @@
       USE wrk_nemo, ONLY:   ze0  => wrk_3d_1 , ze1  => wrk_3d_2 , ze2  => wrk_3d_3
       USE wrk_nemo, ONLY:   ze3  => wrk_3d_4 , zea  => wrk_3d_5
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ze0 ze1 ze2 ze3 zea :I :I :z
       !
       INTEGER, INTENT(in) ::   kt     ! ocean time-step
@@ -102,4 +111,6 @@
       REAL(wp) ::   zc0, zc1, zc2, zc3   !    -         -
       REAL(wp) ::   zz0, zz1, z1_e3t     !    -         -
+
+!FTRANS ztrdt :I :I :z
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt
       !!----------------------------------------------------------------------
@@ -144,11 +155,27 @@
       IF( lk_qsr_bio .AND. ln_qsr_bio ) THEN      !  bio-model fluxes  : all vertical coordinates  !
          !                                        ! ============================================== !
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  qsr_hc(:,:,jk) = ro0cpr * ( etot3(:,:,jk) - etot3(:,:,jk+1) )
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             qsr_hc(:,:,jk) = ro0cpr * ( etot3(:,:,jk) - etot3(:,:,jk+1) )
          END DO
+#endif
          !                                        Add to the general trend
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1 
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   z1_e3t = zfact / fse3t(ji,jj,jk)
                   tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + ( qsr_hc_b(ji,jj,jk) + qsr_hc(ji,jj,jk) ) * z1_e3t
@@ -198,4 +225,9 @@
                zea(:,:,1) =         qsr(:,:)
                !
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     DO jk = 2, nksr+1
+#else
                DO jk = 2, nksr+1
 !CDIR NOVERRCHK
@@ -203,4 +235,5 @@
 !CDIR NOVERRCHK   
                      DO ji = 1, jpi
+#endif
                         zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * xsi0r     )
                         zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t(ji,jj,jk-1) * zekb(ji,jj) )
@@ -216,14 +249,34 @@
                END DO
                !
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     DO jk = 1, nksr                                  ! compute and add qsr trend to ta
+                        qsr_hc(ji,jj,jk) = ro0cpr * ( zea(ji,jj,jk) - zea(ji,jj,jk+1) )
+                     END DO
+                  END DO
+               END DO
+#else
                DO jk = 1, nksr                                        ! compute and add qsr trend to ta
                   qsr_hc(:,:,jk) = ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) )
                END DO
+#endif
                zea(:,:,nksr+1:jpk) = 0.e0     ! below 400m set to zero
                CALL iom_put( 'qsr3d', zea )   ! Shortwave Radiation 3D distribution
                !
             ELSE                                                 !*  Constant Chlorophyll
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     DO jk = 1, nksr
+                        qsr_hc(ji,jj,jk) =  etot3(ji,jj,jk) * qsr(ji,jj)
+                     END DO
+                  END DO
+               END DO
+#else
                DO jk = 1, nksr
                   qsr_hc(:,:,jk) =  etot3(:,:,jk) * qsr(:,:)
                END DO
+#endif
             ENDIF
 
@@ -236,7 +289,13 @@
                zz0   =        rn_abs   * ro0cpr
                zz1   = ( 1. - rn_abs ) * ro0cpr
+#if defined key_z_first
+               DO jj = 2, jpjm1
+                  DO ji = 2, jpim1
+                     DO jk = 1, nksr              ! solar heat absorbed at T-point in the top 400m 
+#else
                DO jk = 1, nksr                    ! solar heat absorbed at T-point in the top 400m 
                   DO jj = 2, jpjm1
                      DO ji = 2, jpim1
+#endif
                         zc0 = zz0 * EXP( -fsdepw(ji,jj,jk  )*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk  )*xsi1r )
                         zc1 = zz0 * EXP( -fsdepw(ji,jj,jk+1)*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk+1)*xsi1r )
@@ -246,7 +305,13 @@
                END DO
             ELSE                                               !* constant volume: coef. computed one for all
+#if defined key_z_first
+               DO jj = 2, jpjm1
+                  DO ji = 2, jpim1
+                     DO jk = 1, nksr
+#else
                DO jk = 1, nksr
                   DO jj = 2, jpjm1
                      DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                         qsr_hc(ji,jj,jk) =  etot3(ji,jj,jk) * qsr(ji,jj)
                      END DO
@@ -259,7 +324,13 @@
          !
          !                                        Add to the general trend
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 1, nksr
+#else
          DO jk = 1, nksr
             DO jj = 2, jpjm1 
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   z1_e3t = zfact / fse3t(ji,jj,jk)
                   tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + ( qsr_hc_b(ji,jj,jk) + qsr_hc(ji,jj,jk) ) * z1_e3t
@@ -293,4 +364,10 @@
    END SUBROUTINE tra_qsr
 
+   !! * Reset control of array index permutation 
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    SUBROUTINE tra_qsr_init
@@ -315,4 +392,8 @@
       USE wrk_nemo, ONLY:   ze0  => wrk_3d_1 , ze1  => wrk_3d_2 , ze2 => wrk_3d_3
       USE wrk_nemo, ONLY:   ze3  => wrk_3d_4 , zea  => wrk_3d_5
+
+      !! DCSE_NEMO: Need additional directives for renamed module variables
+!FTRANS ze0 ze1 ze2 ze3 zea :I :I :z
+
       !
       INTEGER  ::   ji, jj, jk     ! dummy loop indices
@@ -433,4 +514,15 @@
                   !
                   zcoef = ( 1. - rn_abs ) / 3.e0              ! equi-partition in R-G-B
+               
+#if defined key_z_first
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ze0(ji,jj,1) = rn_abs
+                        ze1(ji,jj,1) = zcoef
+                        ze2(ji,jj,1) = zcoef 
+                        ze3(ji,jj,1) = zcoef
+                        zea(ji,jj,1) = tmask(ji,jj,1)         ! = ( ze0+ze1+z2+ze3 ) * tmask
+                        DO jk = 2, nksr+1
+#else
                   ze0(:,:,1) = rn_abs
                   ze1(:,:,1) = zcoef
@@ -438,5 +530,4 @@
                   ze3(:,:,1) = zcoef
                   zea(:,:,1) = tmask(:,:,1)                   ! = ( ze0+ze1+z2+ze3 ) * tmask
-               
                   DO jk = 2, nksr+1
 !CDIR NOVERRCHK
@@ -444,4 +535,5 @@
 !CDIR NOVERRCHK   
                         DO ji = 1, jpi
+#endif
                            zc0 = ze0(ji,jj,jk-1) * EXP( - fse3t_0(ji,jj,jk-1) * xsi0r     )
                            zc1 = ze1(ji,jj,jk-1) * EXP( - fse3t_0(ji,jj,jk-1) * zekb(ji,jj) )
@@ -457,7 +549,17 @@
                   END DO 
                   !
+#if defined key_z_first
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        DO jk = 1, nksr
+                           etot3(ji,jj,jk) = ro0cpr * ( zea(ji,jj,jk) - zea(ji,jj,jk+1) ) 
+                        END DO
+                     END DO
+                  END DO
+#else
                   DO jk = 1, nksr
                      etot3(:,:,jk) = ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) 
                   END DO
+#endif
                   etot3(:,:,nksr+1:jpk) = 0.e0                ! below 400m set to zero
                ENDIF
@@ -481,4 +583,18 @@
                zz0 =        rn_abs   * ro0cpr
                zz1 = ( 1. - rn_abs ) * ro0cpr
+#if defined key_z_first
+               DO jj = 1, jpj                     !*  solar heat absorbed at T-point computed once for all
+                  DO ji = 1, jpi
+                     DO jk = 1, nksr                         ! top 400 meters
+                        zc0 = zz0 * EXP( -fsdepw(ji,jj,jk  )*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk  )*xsi1r )
+                        zc1 = zz0 * EXP( -fsdepw(ji,jj,jk+1)*xsi0r ) + zz1 * EXP( -fsdepw(ji,jj,jk+1)*xsi1r )
+                        etot3(ji,jj,jk) = (  zc0 * tmask(ji,jj,jk) - zc1 * tmask(ji,jj,jk+1)  ) 
+                     END DO
+                     DO jk = nksr+1, jpk
+                        etot3(ji,jj,jk) = 0.e0       ! below 400m set to zero
+                     END DO
+                  END DO
+               END DO
+#else
                DO jk = 1, nksr                    !*  solar heat absorbed at T-point computed once for all
                   DO jj = 1, jpj                              ! top 400 meters
@@ -491,4 +607,5 @@
                END DO
                etot3(:,:,nksr+1:jpk) = 0.e0                   ! below 400m set to zero
+#endif
                !
             ENDIF
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 3211)
@@ -33,4 +33,9 @@
 
    PUBLIC   tra_sbc    ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -108,4 +113,6 @@
       INTEGER  ::   ji, jj, jk, jn           ! dummy loop indices  
       REAL(wp) ::   zfact, z1_e3t, zsrau, zdep
+
+!FTRANS ztrdt ztrds :I :I :z
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traswp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traswp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traswp.F90	(revision 3211)
@@ -12,4 +12,7 @@
    PUBLIC   tra_swap     ! routine called by step.F90
    PUBLIC   tra_unswap   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 3211)
@@ -40,4 +40,12 @@
    INTEGER ::   nzdf = 0   ! type vertical diffusion algorithm used (defined from ln_zdf...  namlist logicals)
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -59,5 +67,6 @@
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
       !!
-      INTEGER  ::   jk                   ! Dummy loop indices
+      INTEGER  ::   ji, jj, jk           ! Dummy loop indices
+!FTRANS ztrdt ztrds :I :I :z
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds   ! 3D workspace
       !!---------------------------------------------------------------------
@@ -88,8 +97,19 @@
 
       IF( l_trdtra )   THEN                      ! save the vertical diffusive trends for further diagnostics
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  ztrdt(ji,jj,jk) = ( ( tsa(ji,jj,jk,jp_tem) - tsb(ji,jj,jk,jp_tem) ) / r2dtra(jk) ) - ztrdt(ji,jj,jk)
+                  ztrds(ji,jj,jk) = ( ( tsa(ji,jj,jk,jp_sal) - tsb(ji,jj,jk,jp_sal) ) / r2dtra(jk) ) - ztrds(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             ztrdt(:,:,jk) = ( ( tsa(:,:,jk,jp_tem) - tsb(:,:,jk,jp_tem) ) / r2dtra(jk) ) - ztrdt(:,:,jk)
             ztrds(:,:,jk) = ( ( tsa(:,:,jk,jp_sal) - tsb(:,:,jk,jp_sal) ) / r2dtra(jk) ) - ztrds(:,:,jk)
          END DO
+#endif
          CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_zdf, ztrdt )
          CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_zdf, ztrds )
@@ -119,4 +139,5 @@
       USE zdfgls
       USE zdfkpp
+#  include "zdftke_ftrans.h90"
       !!----------------------------------------------------------------------
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_exp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 3211)
@@ -36,4 +36,12 @@
 
    PUBLIC   tra_zdf_exp   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -75,4 +83,7 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zwx => wrk_3d_6, zwy => wrk_3d_7     ! 3D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwx zwy :I :I :z
       !
       INTEGER                              , INTENT(in   ) ::   kt          ! ocean time-step index
@@ -81,6 +92,12 @@
       INTEGER                              , INTENT(in   ) ::   kn_zdfexp   ! number of sub-time step
       REAL(wp), DIMENSION(        jpk     ), INTENT(in   ) ::   p2dt        ! vertical profile of tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb         ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta         ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb         ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta         ! tracer trend 
+
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)         ! before and now tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)         ! tracer trend 
       !
       INTEGER  ::  ji, jj, jk, jn, jl        ! dummy loop indices
@@ -116,7 +133,13 @@
          DO jl = 1, kn_zdfexp
             !                     ! first vertical derivative
+#if defined key_z_first
+            DO jj = 2, jpjm1 
+               DO ji = 2, jpim1   ! vector opt.
+                  DO jk = 2, jpk
+#else
             DO jk = 2, jpk
                DO jj = 2, jpjm1 
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      zave3r = 1.e0 / fse3w_n(ji,jj,jk) 
                      IF( cdtype == 'TRA' .AND. jn == jp_tem ) THEN  ! temperature : use of avt
@@ -129,7 +152,14 @@
             END DO
             !
+#if defined key_z_first
+            ! second vertical derivative   ==> tracer at kt+l*2*rdt/nn_zdfexp
+            DO jj = 2, jpjm1 
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1      ! second vertical derivative   ==> tracer at kt+l*2*rdt/nn_zdfexp
                DO jj = 2, jpjm1 
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      ze3tr = zlavmr / fse3t_n(ji,jj,jk)
                      zwx(ji,jj,jk) = zwx(ji,jj,jk) + p2dt(jk) * ( zwy(ji,jj,jk) - zwy(ji,jj,jk+1) ) * ze3tr
@@ -143,7 +173,13 @@
          ! ------------------------------
          IF( lk_vvl ) THEN          ! variable level thickness : leap-frog on tracer*e3t
+#if defined key_z_first
+            DO jj = 2, jpjm1 
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1 
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      ze3tb = fse3t_b(ji,jj,jk) / fse3t(ji,jj,jk)                          ! before e3t
                      ztra  = zwx(ji,jj,jk) - ptb(ji,jj,jk,jn) + p2dt(jk) * pta(ji,jj,jk,jn)       ! total trends * 2*rdt 
@@ -153,7 +189,13 @@
             END DO
          ELSE                       ! fixed level thickness : leap-frog on tracers
+#if defined key_z_first
+            DO jj = 2, jpjm1 
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1 
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      pta(ji,jj,jk,jn) = ( zwx(ji,jj,jk) + p2dt(jk) * pta(ji,jj,jk,jn) ) * tmask(ji,jj,jk)
                   END DO
